include get.e
include file.e
include machine.e

object junk

--targa file handling vars
object scene,rv,bv,gv,ifield,nullchar,picset
global integer idfield,cmaptype,imagetype,originx,originy,wid,height,tgatype,w,h
global sequence rbuf,bbuf,gbuf
global sequence tga
picset=8
ifield=18

tga={0,0,2,0,0,{0,0},{0,0},24,0,0}
idfield=1
cmaptype=2
imagetype=3
originx=4
originy=5
wid=6
height=7
tgatype=8
w=9
h=10
nullchar=0

--gamma level vars
global atom gamma_level,gltemp

gamma_level=1.0

global procedure setbufs(integer w, integer h)
  rbuf=repeat(repeat(0,h),w)
  gbuf=repeat(repeat(0,h),w)
  bbuf=repeat(repeat(0,h),w)
  tga[w]=w
  tga[h]=h
end procedure

global procedure tgar(sequence load)
scene=open(load,"ub")
junk=seek(scene,0)
tga[idfield]=getc(scene)
tga[cmaptype]=getc(scene)
tga[imagetype]=getc(scene)
junk=seek(scene,picset + 0) 
tga[originx]=getc(scene)
junk=getc(scene)
tga[originy]=getc(scene)
junk=getc(scene)
tga[wid][1]=getc(scene)
tga[wid][2]=getc(scene)
tga[height][1]=getc(scene)
tga[height][2]=getc(scene)
tga[w]=tga[wid][1]+tga[wid][2]*256
tga[h]=tga[height][1]+tga[height][2]*256
rbuf=repeat(repeat(0,tga[h]),tga[w])
bbuf=repeat(repeat(0,tga[h]),tga[w])
gbuf=repeat(repeat(0,tga[h]),tga[w])
tga[tgatype]=getc(scene)
junk=seek(scene,ifield)
for n1 = 0 to tga[h]-1 do
  for m1 = 0 to tga[w]-1 do
   bbuf[tga[w] - m1][tga[h] - n1]=getc(scene)
   gbuf[tga[w] - m1][tga[h] - n1]=getc(scene)
   rbuf[tga[w] - m1][tga[h] - n1]=getc(scene)
 end for
end for
close(scene)
end procedure

global procedure tgaw(sequence save)
  sequence tb
  scene=open(save,"wb")
  junk=seek(scene,0)
  puts (scene,tga[idfield])
  puts (scene,tga[cmaptype])
  puts (scene,tga[imagetype])
  puts (scene,nullchar)
  puts (scene,nullchar)
  puts (scene,nullchar)
  puts (scene,nullchar)
  puts (scene,nullchar)
  puts (scene,tga[originx])
  puts (scene,nullchar)
  puts (scene,tga[originy])
  puts (scene,nullchar)
  tb=int_to_bytes(tga[w])
  tga[wid][1]=tb[1]
  tga[wid][2]=tb[2]
  tb=int_to_bytes(tga[h])
  tga[height][1]=tb[1]
  tga[height][2]=tb[2]
  puts (scene,tga[wid][1])
  puts (scene,tga[wid][2])
  puts (scene,tga[height][1])
  puts (scene,tga[height][2])
  puts (scene,tga[tgatype])
  junk=seek(scene,ifield)
  for n1 = 0 to tga[h] - 1 do
    for m1 = 0 to tga[w] - 1 do
     bv = bbuf[tga[w] - m1][tga[h] - n1]
     gv = gbuf[tga[w] - m1][tga[h] - n1]
     rv = rbuf[tga[w] - m1][tga[h] - n1]
     puts(scene,bv)
     puts(scene,gv)
     puts(scene,rv)
    end for
  end for
  close(scene)
end procedure

global procedure gamma(object lev)
for x=1 to tga[w] do
  for y=1 to tga[h] do
    rbuf[x][y]=floor(rbuf[x][y]-(gamma_level*255-255)+(lev*255-255))
    if rbuf[x][y]>255 then rbuf[x][y]=255 end if
    if rbuf[x][y]<0 then rbuf[x][y]=0 end if
    bbuf[x][y]=floor(bbuf[x][y]-(gamma_level*255-255)+(lev*255-255))
    if bbuf[x][y]>255 then bbuf[x][y]=255 end if
    if bbuf[x][y]<0 then bbuf[x][y]=0 end if
    gbuf[x][y]=floor(gbuf[x][y]-(gamma_level*255-255)+(lev*255-255))
    if gbuf[x][y]>255 then gbuf[x][y]=255 end if
    if gbuf[x][y]<0 then gbuf[x][y]=0 end if
  end for
end for
end procedure

global function hist(integer x)
  sequence his
  his=repeat(0,256)
  if x=1 then
    for i=1 to tga[w] do
      for j=1 to tga[h] do
        his[rbuf[i][j]+1]=his[rbuf[i][j]+1]+1
      end for
    end for
  end if 
  if x=2 then
    for i=1 to tga[w] do
      for j=1 to tga[h] do
        his[bbuf[i][j]+1]=his[bbuf[i][j]+1]+1
      end for
    end for
  end if 
  if x=3 then
    for i=1 to tga[w] do
      for j=1 to tga[h] do
        his[gbuf[i][j]+1]=his[gbuf[i][j]+1]+1
      end for
    end for
  end if
  return his
end function

